package org.jboss.seam.selectitems.jsf;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.ConverterException;
import javax.faces.el.ValueBinding;


public class EnumConverter extends SelectItemsConverter {
	
	public static final String CLASS_NOT_FOUND = "org.jboss.seam.selectitems.enumConverter.classNotFound";
	public static final String NOT_AN_ENUM = "org.jboss.seam.selectitems.enumConverter.notAnEnum";

	@SuppressWarnings("unchecked")
	protected Object convertToObject(FacesContext ctx, UIComponent cmp, String value) throws ConverterException {
		ValueBinding vb = cmp.getValueBinding("value");
		if (vb == null) {
			throw new ConverterException(
					getMessage(CLASS_NOT_FOUND));
		}
		Class enumType = vb.getType(ctx);
		if (Enum.class.isAssignableFrom(enumType)) {
			return Enum.valueOf(enumType, value);
		} else {
			throw new ConverterException(getMessage(NOT_AN_ENUM) + " " +enumType.getName());
		}
	}

	protected String convertToString(FacesContext ctx, UIComponent cmp, Object value) throws ConverterException {
		if (value == null) {
			return null;
		}
		if (value instanceof Enum) {
			Enum type = (Enum) value;
			return type.name();
		} else {
			throw new ConverterException(getMessage(NOT_AN_ENUM) + value.getClass().getName());
		}
		
	}

}
